<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="fr"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../.resources/report.css" type="text/css"/><link rel="shortcut icon" href="../.resources/report.gif" type="image/gif"/><title>Controller.java</title><link rel="stylesheet" href="../.resources/prettify.css" type="text/css"/><script type="text/javascript" src="../.resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../.sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">JaCoCoverage analysis of project &quot;ATL-OTHELLO-Monir&quot; (powered by JaCoCo from EclEmma)</a> &gt; <a href="index.source.html" class="el_package">esi.atl.othello.monir.controller</a> &gt; <span class="el_source">Controller.java</span></div><h1>Controller.java</h1><pre class="source lang-java linenums">package esi.atl.othello.monir.controller;

import esi.atl.othello.monir.model.Game;
import esi.atl.othello.monir.model.Position;
import esi.atl.othello.monir.view.View;

/**
 * This class represents the controller.
 *
 * @author Monir Nasser
 */
public class Controller {

    private Game game;
    private View view;

<span class="nc" id="L17">    public Controller(Game game, View view) {</span>
<span class="nc bnc" id="L18" title="All 4 branches missed.">        if (game == null || view == null) {</span>
<span class="nc" id="L19">            throw new NullPointerException(&quot;The game is null&quot; + game</span>
                    + &quot; or the view &quot; + view);
        }
<span class="nc" id="L22">        this.game = game;</span>
<span class="nc" id="L23">        this.view = view;</span>
<span class="nc" id="L24">    }</span>

    /**
     * This method allows us to start the drawing and keep them still the player
     * hasn't quit.this methods ask what the player wants to do.
     */
    public void start() {
<span class="nc" id="L31">        boolean quit = false;</span>
<span class="nc" id="L32">        game.initialize();</span>
<span class="nc" id="L33">        view.displayBoard(game.getBoard());</span>
<span class="nc" id="L34">        view.displayCurrentPlayer(game.getCurrent());</span>
        do {
            try {
<span class="nc" id="L37">                String[] command = view.askCommand().toLowerCase().split(&quot; &quot;);</span>
<span class="nc" id="L38">                quit = userChoice(command);</span>
<span class="nc" id="L39">                view.displayCurrentPlayer(game.getCurrent());</span>
<span class="nc" id="L40">            } catch (Exception e) {</span>
<span class="nc" id="L41">                System.out.println(e.getMessage());</span>
<span class="nc" id="L42">            }</span>
<span class="nc bnc" id="L43" title="All 4 branches missed.">        } while (!quit || !game.isOver());</span>
<span class="nc" id="L44">        view.quit();</span>
<span class="nc" id="L45">    }</span>

    /**
     * This method verify what the player has enter in the command.
     *
     * @param command The string tab.
     * @return boolean if he quit or not.
     */
    public boolean userChoice(String[] command) {
<span class="nc" id="L54">        boolean quit = false;</span>
<span class="nc bnc" id="L55" title="All 25 branches missed.">        switch (command[0]) {</span>
            case &quot;quit&quot;:
<span class="nc" id="L57">                quit = true;</span>
<span class="nc" id="L58">                break;</span>
            case &quot;?&quot;:
            case &quot;help&quot;:
<span class="nc" id="L61">                view.displayHelp();</span>
<span class="nc" id="L62">                break;</span>
            case &quot;show&quot;:
<span class="nc" id="L64">                view.displayBoard(game.getBoard());</span>
<span class="nc" id="L65">                break;</span>
            case &quot;score&quot;:
<span class="nc" id="L67">                view.displayValuesOfPlayers(game.valuePieces(), game.getCurrent(), game.getOpponent());</span>
<span class="nc" id="L68">                break;</span>
            case &quot;play&quot;:
<span class="nc" id="L70">                Position pos = new Position(Integer.parseInt(command[1]), nbLetters(command[2]));</span>
<span class="nc bnc" id="L71" title="All 2 branches missed.">                if (game.isValidMoveAllDirection(pos)) {</span>
<span class="nc" id="L72">                    game.putPiece(pos);</span>
<span class="nc" id="L73">                    view.displayBoard(game.getBoard());</span>
                } else {
<span class="nc" id="L75">                    System.out.println(&quot;Invalid Move&quot;);</span>
                }
                break;
        }
<span class="nc" id="L79">        return quit;</span>
    }

    /**
     * This method change a string at the corresponding number;
     *
     * @param command The string
     * @return An int.
     */
    public int nbLetters(String command) {
<span class="nc" id="L89">        int k = 0;</span>
<span class="nc bnc" id="L90" title="All 34 branches missed.">        switch (command) {</span>
            case &quot;a&quot;:
<span class="nc" id="L92">                k = 0;</span>
<span class="nc" id="L93">                break;</span>
            case &quot;b&quot;:
<span class="nc" id="L95">                k = 1;</span>
<span class="nc" id="L96">                break;</span>
            case &quot;c&quot;:
<span class="nc" id="L98">                k = 2;</span>
<span class="nc" id="L99">                break;</span>
            case &quot;d&quot;:
<span class="nc" id="L101">                k = 3;</span>
<span class="nc" id="L102">                break;</span>
            case &quot;e&quot;:
<span class="nc" id="L104">                k = 4;</span>
<span class="nc" id="L105">                break;</span>
            case &quot;f&quot;:
<span class="nc" id="L107">                k = 5;</span>
<span class="nc" id="L108">                break;</span>
            case &quot;g&quot;:
<span class="nc" id="L110">                k = 6;</span>
<span class="nc" id="L111">                break;</span>
            case &quot;h&quot;:
<span class="nc" id="L113">                k = 7;</span>
<span class="nc" id="L114">                break;</span>
            default:
<span class="nc" id="L116">                throw new IllegalArgumentException(&quot;The second position&quot;</span>
                        + &quot; is not an integer &quot;
                        + &quot;or the letters is not in the column&quot;);
        }
<span class="nc" id="L120">        return k;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.6.201602180812</span></div></body></html>